<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from lic.texi on 28 April 1999 -->

<TITLE>The Linear Inequality Calculator - Prototyping System Syntax</TITLE>
<link href="lic_9.html" rel=Next>
<link href="lic_7.html" rel=Previous>
<link href="lic_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_7.html">previous</A>, <A HREF="lic_9.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC8" HREF="lic_toc.html#TOC8">Prototyping System Syntax</A></H2>
<P>
<A NAME="IDX49"></A>
<A NAME="IDX50"></A>

</P>
<P>
In this mode, <CODE>LIC</CODE> can be used to rapidly implement and test
linear inequality based algorithms used for loop level code generation.
The following is the command syntax for this mode.

</P>

<UL>

<LI>

Simple arithmetic operations are available for integers and integer
variables (see section <A HREF="lic_7.html#SEC7">Types of Variables</A>) (<CODE>'+'   '-'   '*'   '/'</CODE>).
<A NAME="IDX51"></A>
<A NAME="IDX52"></A>
<A NAME="IDX53"></A>
<A NAME="IDX54"></A>
<A NAME="IDX55"></A>
<A NAME="IDX56"></A>

<LI>

Inequality systems can be created by describing the inequalities by the
variables used within the inequalities (see section <A HREF="lic_7.html#SEC7">Types of Variables</A>). 
A system of inequalities is described within square brackets
<SAMP>`[...]'</SAMP>. Each inequality should be separated by a new line. 
<A NAME="IDX57"></A>
<A NAME="IDX58"></A>
<A NAME="IDX59"></A>
<A NAME="IDX60"></A>
<A NAME="IDX61"></A>
<A NAME="IDX62"></A>
<A NAME="IDX63"></A>
<A NAME="IDX64"></A>
<A NAME="IDX65"></A>
<A NAME="IDX66"></A>
<A NAME="IDX67"></A>
<A NAME="IDX68"></A>
<A NAME="IDX69"></A>

<PRE>
iter = [ 0 &#60;= ir &#60;= U
         0 &#60;= jr &#60;= U ]
decomp =  [ 32*Pr &#60;= ir &#60; 32*Pr + L 
            32*Pw &#60;= iw &#60; 32*Pw + L ]
lwt = [ iw = 2*ir - 1
        jw = jr ]
</PRE>

<A NAME="IDX70"></A>

<LI>

This program can also handle linear inequalities with symbolic
coefficients.  However there are some restrictions.  The systems should be
able to be solved using Fourier-Motzkin pair-wise elimination without
creating more complex coefficient terms other 
than a coefficient with a single symbolic constant and an integer
multiplier.  The first use of a variable that is used as a symbolic
coefficient has to clearly be a symbolic coefficient (see section <A HREF="lic_7.html#SEC7">Types of Variables</A>). The terms with symbolic coefficients has to be of the form <BR>
<KBD> &#60;integer&#62;*&#60;symbolic coefficient&#62;*&#60;index variable&#62;</KBD> or <BR>
<KBD> &#60;symbolic coefficient&#62;*&#60;index variable&#62;</KBD>.
<A NAME="IDX71"></A>
<A NAME="IDX72"></A>
<A NAME="IDX73"></A>
<A NAME="IDX74"></A>
<A NAME="IDX75"></A>
<A NAME="IDX76"></A>

<PRE>
   decomp = [ L*Pr &#60;= i &#60;= L*Pr + L - 1]
</PRE>

<A NAME="IDX77"></A>

<LI>

Multiple systems stored in Inequality variables as well as new systems
of inequalities can be concatenated by listing them
separated by commas (<SAMP>`,'</SAMP>) or a new line. The entry should be
delimited by curly braces ({...}).
<A NAME="IDX78"></A>
<A NAME="IDX79"></A>

<PRE>
   res = { iter, decomp, lwt }
   nocomm = { res
              [ Pr == Pw ] }
</PRE>

<A NAME="IDX80"></A>

<LI>S.realsol()

<LI>realsol(S)

<LI>S.rsol()

<LI>rsol(S)

<LI>S.rsolution()

<LI>S.realsolution()

<LI>realsolution(S)

<BR> All of these are equivalent and check if there exists a real solution to
the system of inequalities <SAMP>`S'</SAMP> using the Fourier-Motzkin
Elimination technique. This function returns an integer. The return
value is 1 if there exists a real solution, 0 otherwise.
<A NAME="IDX81"></A>
<A NAME="IDX82"></A>
<A NAME="IDX83"></A>
<A NAME="IDX84"></A>
<A NAME="IDX85"></A>
<A NAME="IDX86"></A>
<A NAME="IDX87"></A>

<LI>S.integersol()

<LI>integersol(S)

<LI>S.intsol()

<LI>intsol(S)

<LI>S.isol()

<LI>isol(S)

<LI>S.isolution()

<LI>isolution(S)

<LI>S.intsolution()

<LI>intsolution(S)

<LI>S.integersolution()

<LI>integersolution(S)

<BR> All of these are equivalent and check if there exists an integer
solution to the system of inequalities <SAMP>`S'</SAMP> using Fourier-Motzkin
Elimination for elimination and a branch-and-bound technique to find an
integer solution. This function returns an integer. The return value is
1 if there exists a real solution, 0 otherwise.  This function is only
available when there are no symbolic coefficients since branch-and-bound
is not currently implemented in the library of linear inequalities with
symbolic coefficients.
<A NAME="IDX88"></A>
<A NAME="IDX89"></A>
<A NAME="IDX90"></A>
<A NAME="IDX91"></A>
<A NAME="IDX92"></A>
<A NAME="IDX93"></A>
<A NAME="IDX94"></A>
<A NAME="IDX95"></A>
<A NAME="IDX96"></A>
<A NAME="IDX97"></A>

<LI>S.project()

<LI>S.proj()

<BR> These are equivalent and perform full pair-wise Fourier-Motzkin
elimination. The resulting system of inequalities will have all the
inequalities created while performing the Fourier-Motzkin pair-wise
elimination.
<A NAME="IDX98"></A>
<A NAME="IDX99"></A>
<A NAME="IDX100"></A>
<A NAME="IDX101"></A>

<LI>S.project(ir)

<LI>S.proj(ir)

<BR> These are equivalent and perform pair-wise Fourier-Motzkin elimination
for the variable <SAMP>`ir'</SAMP>. The variable <SAMP>`ir'</SAMP> should be a part of
the system <SAMP>`S'</SAMP>.  The resulting system of inequalities will contain
all the inequalities of <SAMP>`S'</SAMP> that did not contain the variable
<SAMP>`ir'</SAMP>.  The inequalities that contained the variable <SAMP>`ir'</SAMP> will
be replaced by the inequalities generated by pair-wise projection of
<SAMP>`ir'</SAMP>.
<A NAME="IDX102"></A>
<A NAME="IDX103"></A>
<A NAME="IDX104"></A>
<A NAME="IDX105"></A>

<LI>S.simplify()

<LI>S.simp()

<BR> These are equivalent and perform full pair-wise Fourier-Motzkin
elimination and eliminates all the redundant inequalities from the
resulting system.  The heuristics used to eliminate the redundant
inequalities are the same as are used to find the tightest loop bounds.
<A NAME="IDX106"></A>
<A NAME="IDX107"></A>
<A NAME="IDX108"></A>
<A NAME="IDX109"></A>
<A NAME="IDX110"></A>
<A NAME="IDX111"></A>

<LI>S.order(a b c d)

<LI>S.ord(a b c d)

<BR> These are equivalent and cause the system of linear inequalities to be
ordered such that the variables are arranged from <SAMP>`a'</SAMP> to <SAMP>`d'</SAMP>.
This ordering is needed for the commands <SAMP>`project()'</SAMP>,
<SAMP>`rename()'</SAMP> and <SAMP>`code()'</SAMP>.  All the variables in the system
<SAMP>`S'</SAMP> have to be included in the ordering.  For example,

<PRE>
S = S.order(i j k)
S.code()
</PRE>

<A NAME="IDX112"></A>

will make the command <SAMP>`code()'</SAMP> treat the variable <SAMP>`i'</SAMP> as the
outer loop nest and variable <SAMP>`k'</SAMP> as the inner loop nest.

<LI>S.rename(a b c d)

<LI>S.ren(a b c d)

<BR> These are equivalent and cause the ordered system of inequalities to be
renamed using the new variables.  All the variables in the system
<SAMP>`S'</SAMP> (except the symbolic coefficient variables) have to be renamed.
<A NAME="IDX113"></A>
<A NAME="IDX114"></A>

<PRE>
S = [ i &#62; 2*j + k ] 
S = S.order(i j k)
S = S.rename(p q k)
</PRE>

<A NAME="IDX115"></A>

will result in an inequality

<PRE>
[p &#62; 2*q + k]
</PRE>

<A NAME="IDX116"></A>

<LI>S.code()

<LI>S.cd()

<LI>S.code(n)

<LI>S.cd(n)

<BR> All of these are equivalent and print the loop nest corresponding to the
system <SAMP>`S'</SAMP>. See order() for the format of the resulting loop nest.
If an integer value <SAMP>`n'</SAMP> is given, the first <SAMP>`n-1'</SAMP> variables,
i.e. outermost loop nests, will not be printed.  This is used to avoid
printing loop nests for constant variables.

<LI>merge()

<LI>test()

<BR> These keywords are reserved for testing and debugging, and thus cannot
be used as variable names.

</UL>

<P><HR><P>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_7.html">previous</A>, <A HREF="lic_9.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
</BODY>
</HTML>
